
dofile("scripts/inc_mapsave.lua")

local function isZoneDone(m)
    local done = v.getDoneMapsByEntryMap(m)
    local total = v.getTotalMapsByEntryMap(m)
    return done >= total
end

local function allZonesDone()
    return isZoneDone("main_reef")
       and isZoneDone("main_abyss")
       and isZoneDone("main_desert")
       and isZoneDone("main_volcano")
       and isZoneDone("main_nightmare")
end

function init(me)
    if allZonesDone() then
        local door = node_getNearestEntity(me, "energydoor")
        if door == 0 then
            errorLog("node_openlastdoor.lua: No door found!")
            return
        end
        entity_setState(door, STATE_OPEN)
        
        local wl = getNode("hub_waterlevel")
        if wl == 0 then
            errorLog("node_openlastdoor.lua: No hub_waterlevel node found!")
            return
        end
        
        setWaterLevel(node_y(wl))
    end
end

function update(me, dt)
end

function activate(me)
end

function songNote(me, note)
end

function songNoteDone(me, note, done)
end
